import { type FC, type ReactNode } from "react";
type ProviderProps<TArgs> = {
    children?: ReactNode;
} & TArgs;
type Result<TValue, TName extends string, TArgs> = {
    [K in `use${TName}Context` | `${TName}Provider`]: K extends `use${TName}Context` ? () => TValue : K extends `${TName}Provider` ? FC<ProviderProps<TArgs>> : never;
};
declare function typesafeContextHook<TName extends string, TValue, TArgs extends object>(name: TName, hook: (args: TArgs) => TValue): Result<TValue, TName, TArgs>;
export default typesafeContextHook;
